#include <iostream>
#include <stdlib.h>

using namespace std;

int main()
{
    int n,o,a,b,ab;cin>>n;
    cin>>o>>a>>b>>ab;
    int o1=o,a1=a,b1=b,ab1=ab;
    string ime;int broj;
    int mat[n][4]={0};
    string x="da";
    for (int i=0;i<n;i++)
    {
        cin>>ime>>broj;
        if (ime=="O" && (broj-o)>0)
        {
            x="nemoguce";
        }
        else if(ime=="O" && (broj-o)<=0)
        {
            mat[i][0]=broj;
            o=o-broj;
        }
        else if(ime=="A" && (broj-a)<=0)
        {
            mat[i][1]=broj;
            a=a-broj;
        }
        else if(ime=="A" && (broj-a)>0)
        {
            if (broj-a-o>0)
            {
                x="nemoguce";
            }
            else
            {
                mat[i][0]=broj-a;
                o=abs(broj-a-o);
                mat[i][1]=a;
                a=0;
            }
        }
        else if(ime=="B" && (broj-b)<=0)
        {
            mat[i][2]=broj;
            b=b-broj;
        }
        else if(ime=="B" && (broj-b)>0)
        {
            if (broj-b-o>0)
            {
                x="nemoguce";
            }
            else
            {
                mat[i][0]=broj-b;
                o=abs(broj-b-o);
                mat[i][2]=b;
                b=0;
            }
        }
        else if(ime=="AB" && (broj-ab)<=0)
        {
            mat[i][3]=broj;
            ab=ab-broj;
        }
        else if(ime=="AB" && (broj-ab)>0)
        {
            if (broj-ab-o>0)
            {
                if (broj-ab-o-a>0)
                {
                    if(broj-ab-o-a-b>0)
                    {
                        x="nemoguce";
                    }
                    else
                    {
                        mat[i][2]=broj-b;
                        b=abs(broj-ab-o-a-b);
                        ab=0;
                        mat[i][3]=ab;
                        a=0;
                        mat[i][1]=a;
                        o=0;
                        mat[i][0]=o;
                    }
                }
                else
                {
                    mat[i][1]=broj-a;
                    a=abs(broj-ab-o-a);
                    ab=0;
                    mat[i][3]=ab;
                    o=0;
                    mat[i][0]=o;
                }
            }
            else
            {
                mat[i][0]=broj-ab;
                o=abs(broj-ab-o);
                mat[i][3]=ab;
                ab=0;
            }
        }
    }
    if (x=="nemoguce")
    {
        cout<<x;
    }
    else
    {
        for (int i=0;i<n;i++)
        {
            for (int j=0;j<4;j++)
            {
                cout<<mat[i][j]<<" ";
            }
            cout<<endl;
        }
    }

    return 0;
}